package hu.kozadat.search.base.preprocessor;

import org.springframework.stereotype.Component;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * User: codex
 */
@Component("andOrPreprocessor")
public class AndOrPreprocessor extends QueryPreprocessor {

    private static final Pattern andPattern = Pattern.compile("[\\s]+és[\\s]+", Pattern.CASE_INSENSITIVE | Pattern.UNICODE_CASE);
    private static final Pattern orPattern = Pattern.compile("[\\s]+vagy[\\s]+", Pattern.CASE_INSENSITIVE | Pattern.UNICODE_CASE);

    public QueryPreprocessorResult preprocess(String segment, boolean appendFieldName) {
        QueryPreprocessorResult res = new QueryPreprocessorResult();
        res.setOriginalQuery(segment);

        Matcher andMatcher = andPattern.matcher(segment);
        String filteredQuery = andMatcher.replaceAll(" AND ");

        Matcher orMatcher = orPattern.matcher(filteredQuery);
        filteredQuery = orMatcher.replaceAll(" OR ");

        res.setFilteredQuery(filteredQuery);
        res.setQueryModified(segment.equals(filteredQuery));
        return res;
    }
}
