package hu.kozadat.search.persistence;

import hu.kozadat.search.exception.UserOperationException;
import hu.scriptum.einfoszab.datamodel.Contact;
import hu.scriptum.einfoszab.datamodel.ContactInfo;
import hu.scriptum.einfoszab.datamodel.Person;

import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.23.
 * Time: 9:44
 * To change this template use File | Settings | File Templates.
 */
public interface UserOperations {

    Person getLoggedPerson(String loginName) throws UserOperationException;

    void deletePerson(Person person) throws UserOperationException;

    Map<String, Integer> deletePersonInternal(String loginName);

    void savePerson(Person person) throws UserOperationException;

    void savePersonInternal(Person person);

    void createPerson(Person person) throws UserOperationException;

    void createPersonInternal(Person person) throws UserOperationException;

    void changePassword(String loginName, String oldPassword, String newPassword, String changeRole) throws UserOperationException;

    List getPersons(String userGroupName);

    void addUserPhones(Person p);

    int deleteUserPhones(String loginName);

    void addUserEmails(Person p);

    Map<String, Integer> deleteResponsible(Person responsible);

    String promoteAContact(long dataProviderId);

    int deleteUserEmails(String loginName);

    List<ContactInfo> getContactInfos(String dataProviderName);

    Person getPersonByLoginName(String loginName);

    Contact getContactByLoginName(String loginName);

    List<Person> getContacts(long dataProviderId, String role);

    int updatePerson(Person p);

    int updateContact(Contact c);

    boolean existsWithLoginName(String loginName);
}
