/**
 * Created by IntelliJ IDEA.
 * User: tnagy
 * Date: 2009.11.10.
 * Time: 16:55:15
 */
package hu.kozadat.search.persistence.institutionsearch;

import hu.kozadat.search.model.InstitutionSearchResultItem;

import java.text.Collator;
import java.util.Comparator;
import java.util.Locale;

public class InstitutionSearchResultItemNameComparator implements Comparator<InstitutionSearchResultItem> {
    public static final String LOCALE_HU_HU = "hu_HU";

    private Locale locale;
    private Collator collator;

    public InstitutionSearchResultItemNameComparator() {
        this.locale = new Locale(LOCALE_HU_HU);
        this.collator = Collator.getInstance(locale);
    }

    public InstitutionSearchResultItemNameComparator(Locale locale) {
        if (locale != null) {
            this.locale = locale;
            this.collator = Collator.getInstance(locale);
        } else {
            throw new IllegalArgumentException("Parameter 'locale' cannot be null");
        }
    }

    public int compare(InstitutionSearchResultItem o1, InstitutionSearchResultItem o2) {
        if (o1 == null && o2 == null) {
            return 0;
        } else if (o1 == null) {
            return -1;
        } else if (o2 == null) {
            return 1;
        } else {
            // tnagy mantis issue fix 0001448
            if (o1.getType().getStatusOrder() < o2.getType().getStatusOrder()) {
                return -1;
            } else if (o1.getType().getStatusOrder() > o2.getType().getStatusOrder()) {
                return 1;
            }
            if (o1.getInstitutionName() == null && o2.getInstitutionName() == null) {
                return 0;
            } else if (o1.getInstitutionName() == null) {
                return -1;
            } else if (o2.getInstitutionName() == null) {
                return 1;
            } else {
                return collator.compare(o1.getInstitutionName(), o2.getInstitutionName());
            }
        }
    }

}
