package hu.kozadat.search.presentation;

import hu.kozadat.search.model.ResultItem;
import hu.kozadat.search.persistence.DataProviderOperations;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.view.RedirectView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * User: codex
 */
@Deprecated
// @Controller
public class DataProviderResultController {

    private static final Logger LOGGER = LoggerFactory.getLogger(DataProviderResultController.class);

    private DataProviderOperations dataProviderOperations;

    private Map cachedReferenceData;

    @Autowired
    public void setDataProviderOperations(DataProviderOperations dataProviderOperations) {
        this.dataProviderOperations = dataProviderOperations;
    }

    protected Map referenceData(HttpServletRequest request) throws Exception {
        if (cachedReferenceData == null) {
            cachedReferenceData = new HashMap();

            List schemas = dataProviderOperations.getSupportedSchemas();
            cachedReferenceData.put("schemas", schemas);
        }

        return cachedReferenceData;
    }

    @RequestMapping("/dpresults.html")
    public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        referenceData(request);

        Map resultMap = (Map) request.getSession().getAttribute("resultMap");
        if (resultMap != null) {
            ModelAndView mav = new ModelAndView("dpresults");
            int id = ServletRequestUtils.getIntParameter(request, "institutionId", 0);

            Map<Long, List<ResultItem>> dpResultList = (Map<Long, List<ResultItem>>) resultMap.get("dataProviderResults");
            List<ResultItem> resultItems = dpResultList.get(new Long(id));

            mav.addObject("results", resultItems);
            mav.addObject("schemas", cachedReferenceData.get("schemas"));

            return mav;
        } else {
            return new ModelAndView(new RedirectView("index.html", true));
        }
    }
}
