package hu.kozadat.search.presentation;

import hu.kozadat.search.model.ResultItem;
import hu.kozadat.search.service.log.SearchLogger;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;
import org.springframework.web.servlet.view.RedirectView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * Talalati listabol direktben az eredeti rekordra ugrunk.
 *
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
@Deprecated
public class RedirectController extends AbstractController {

    private static final Logger LOGGER = LoggerFactory.getLogger(RedirectController.class);

    private String[] URL_PREFIXES = {"http://", "https://"};
    private int URL_PREFIX_DEFAULT_INDEX = 0;

    private SearchLogger searchLogger;

    public void setSearchLogger(SearchLogger searchLogger) {
        this.searchLogger = searchLogger;
    }

    protected String extendUrlWithProtocol(String url) {
        String res = url;
        boolean startsWithProtocol = false;

        for (String actProt : URL_PREFIXES) {
            if (url.startsWith(actProt)) {
                startsWithProtocol = true;
                break;
            }
        }

        if (!startsWithProtocol) {
            res = URL_PREFIXES[URL_PREFIX_DEFAULT_INDEX] + url;
        }

        return res;
    }

    protected ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Map resultMap = (Map) request.getSession().getAttribute("resultMap");
        if (resultMap != null) {
            Map<Long, List<ResultItem>> dataProviderResults = (Map<Long, List<ResultItem>>) resultMap.get("dataProviderResults");
            int id = ServletRequestUtils.getIntParameter(request, "id", 0) - 1;
            long dpId = ServletRequestUtils.getLongParameter(request, "dpId", 0);

            List<ResultItem> itemLst = dataProviderResults.get(dpId);
            ResultItem item = (ResultItem) itemLst.get(id);

            searchLogger.addOriginalViewLog(request.getRemoteHost(), item.getId(), item.getDataProviderId(), item.getTitle());

            String url = item.getUrl();
            if (url == null) {
                url = "";
            } else {
                url = url.replaceAll("&amp;", "&");
            }

            url = extendUrlWithProtocol(url);

            ModelAndView mav = new ModelAndView(new RedirectView(url));
            return mav;
        } else {
            return new ModelAndView(new RedirectView("index.html", true));
        }
    }
}
