package hu.kozadat.search.presentation;

import hu.kozadat.search.model.ResultItem;
import hu.kozadat.search.service.log.SearchLogger;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;
import org.springframework.web.servlet.view.RedirectView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * Talalati listabol egy metarekord kivalasztasakor ide megyunk.
 *
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
@Deprecated
public class ResultController extends AbstractController {

    private SearchLogger searchLogger;
    private String modelViewName;

    public static final String MODEL_VIEW_NAME_DEFAULT = "showrecord";

    public ResultController() {
        modelViewName = MODEL_VIEW_NAME_DEFAULT;
    }

    public void setSearchLogger(SearchLogger searchLogger) {
        this.searchLogger = searchLogger;
    }

    public void setModelViewName(String modelViewName) {
        this.modelViewName = modelViewName;
    }

    protected ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Map resultMap = (Map) request.getSession().getAttribute("resultMap");
        if (resultMap != null) {
            int id = ServletRequestUtils.getIntParameter(request, "id", 0) - 1;
            String dp = com.actiwise.einfoszab.Utils.null2String(request.getParameter("dp"));

            List<ResultItem> resultList;
            if ("true".equals(dp)) {
                int dataProviderId = ServletRequestUtils.getIntParameter(request, "institutionId", 0);
                Map<Long, List<ResultItem>> dpMap = (Map<Long, List<ResultItem>>) resultMap.get("dataProviderResults");
                resultList = dpMap.get(new Long(dataProviderId));
            } else {
                resultList = (List<ResultItem>) resultMap.get("results");
            }
            ResultItem item = (ResultItem) resultList.get(id);

            String searchExpr = com.actiwise.einfoszab.Utils.null2String(item.getTitle());
            int length = searchExpr.length() <= 150 ? searchExpr.length() : 150;
            searchLogger.addMetarecordViewLog(request.getRemoteHost(), item.getId(), item.getDataProviderId(), length > 0 ? searchExpr.substring(0, length - 1) : searchExpr);

            ModelAndView mav = new ModelAndView(modelViewName);
            mav.addObject("record", item);
            mav.addObject("id", new Integer(id + 1));
            mav.addObject("referer", getUrl(request));

            return mav;
        } else {
            return new ModelAndView(new RedirectView("index.html", true));
        }
    }

    private String getUrl(HttpServletRequest request) {
        String returnValue = null;

        String referer = request.getHeader("Referer");

        if (referer == null) {
            referer = "results.html";
        }

        if (referer.indexOf("results.html") > 0) {
            int indexOfCss = referer.indexOf("css=");
            if (indexOfCss > 0) {
                returnValue = referer.substring(0, indexOfCss);
                if (returnValue.endsWith("&")) {
                    returnValue = returnValue.substring(0, returnValue.length() - 1);
                }
            } else {
                returnValue = referer;
            }
            request.getSession().setAttribute("resultsPage", returnValue);
        } else {
            returnValue = (String) request.getSession().getAttribute("resultsPage");
            if (returnValue == null) {
                returnValue = "results.html";
            }
        }

        return returnValue;
    }
}
