package hu.kozadat.search.web.listener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.21.
 * Time: 11:29
 * To change this template use File | Settings | File Templates.
 */
@WebListener
public class ApplicationInitializer implements ServletContextListener {

    private static final Logger LOGGER = LoggerFactory.getLogger(ApplicationInitializer.class);

    public void contextInitialized(ServletContextEvent servletContextEvent) {
        LOGGER.info("Starting Kozadat SearchUI...");
        LOGGER.info("Kozadat SearchUI started.");
    }

    public void contextDestroyed(ServletContextEvent servletContextEvent) {
        LOGGER.info("Stopping Kozadat SearchUI...");

        LOGGER.info("Deregistering JDBC driver...");
        try {
            String jdbcDriverUrl = "jdbc:sapdb://localhost:7210/EINFOSZA";
            Driver oaiCentralDriver = DriverManager.getDriver(jdbcDriverUrl);
            DriverManager.deregisterDriver(oaiCentralDriver);
            LOGGER.info("JDBC driver deregistered.");
        } catch (SQLException e) {
            LOGGER.error(e.getMessage(), e);
        }

        LOGGER.info("Kozadat SearchUI stopped.");
    }
}
